/* =============================================================================
 *
 *  Description: This is a C implementation for Thread BlinkLED
 *
 * -----------------------------------------------------------------------------
 *  Comments:
 *
 * ===========================================================================*/

/* Get access to any of the VDK features & datatypes used */
#include "BlinkLED.h"
#include <cdefbf533.h>  // Added (JWS)

#define PF2_LED_CS	0x04		// SPI boot CS and LED toggle

section("sdram0") void
BlinkLED_RunFunction(void **inPtr)
{
    /* Put the thread's "main" Initialization HERE */
	int delay=0x40000;
	short led_display;
	int i;

    while (1)
    {
		while (delay--); 
		delay=0x40000;
		while (delay--);
		delay=0x40000;
		
		VDK_PendSemaphore(kBlink, 0);
		for(i=0; i<30; i++)
		{
   			while (delay--);
   			
//   (JWS) old code for EZKIT		
			// flash A csio reg (portA,B data reg)
/*			led_display = *pFlashA_PortB_Data;
			
			if (led_display & 0x1)
				*pFlashA_PortB_Data &= ~0x1;	// if set, clear it
			else
				*pFlashA_PortB_Data |= 0x1;		// if clear, set it
*/
//   (JWS) new code for Dalton's PMP
/*
			led_display = *pFIO_FLAG_D;
			
			if (led_display & 0x0004)
				*pFIO_FLAG_C = PF2_LED_CS;		// if set, clear it
			else
				*pFIO_FLAG_S = PF2_LED_CS;		// if clear, set it
*/

			*pFIO_FLAG_T = PF2_LED_CS;		// Toggle the LED 30 times				
			
			delay = 0x40000;
		}
    }

    /* Put the thread's exit from "main" HERE */
    /* A thread is automatically Destroyed when it exits its run function */
}

int
BlinkLED_ErrorFunction(void **inPtr)
{

    /* TODO - Put this thread's error handling code HERE */

      /* The default ErrorHandler goes to KernelPanic */

	VDK_CThread_Error(VDK_GetThreadID());
	return 0;
}

void
BlinkLED_InitFunction(void **inPtr, VDK_ThreadCreationBlock *pTCB)
{
    /* Put code to be executed when this thread has just been created HERE */

    /* This routine does NOT run in new thread's context.  Any non-static thread
     *   initialization should be performed at the beginning of "Run()."
     */
}

void
BlinkLED_DestroyFunction(void **inPtr)
{
    /* Put code to be executed when this thread is destroyed HERE */

    /* This routine does NOT run in the thread's context.  Any VDK API calls
     *   should be performed at the end of "Run()."
     */
}

/* ========================================================================== */
